/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*
 *  (C) 2008 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */

#ifndef BSCI_H_INCLUDED
#define BSCI_H_INCLUDED

struct HYD_BSCI_info {
    char *bootstrap_exec;
    int  enablex;
    int  debug;
};

struct HYD_BSCI_fns {
    HYD_Status(*launch_procs) (char **global_args, char *partition_id_str,
                               struct HYD_Partition *partition_list);
    HYD_Status(*finalize) (void);
    HYD_Status(*wait_for_completion) (struct HYD_Partition *partition_list);
    HYD_Status(*query_node_list) (int num_nodes, struct HYD_Partition **partition_list);
    HYD_Status(*query_usize) (int *size);
    HYD_Status(*query_partition_id) (int *partition_id);
};

extern struct HYD_BSCI_fns HYD_BSCI_fns;

HYD_Status HYD_BSCI_init(char *bootstrap, char *bootstrap_exec, int enablex, int debug);
HYD_Status HYD_BSCI_launch_procs(char **global_args, char *partition_id_str,
                                 struct HYD_Partition *partition_list);
HYD_Status HYD_BSCI_finalize(void);
HYD_Status HYD_BSCI_wait_for_completion(struct HYD_Partition *partition_list);
HYD_Status HYD_BSCI_query_node_list(int num_nodes, struct HYD_Partition **partition_list);
HYD_Status HYD_BSCI_query_usize(int *size);
HYD_Status HYD_BSCI_query_partition_id(int *partition_id);

/* Each bootstrap server has to expose an initialization function */

HYD_Status HYD_BSCI_ssh_init(void);
HYD_Status HYD_BSCI_rsh_init(void);
HYD_Status HYD_BSCI_fork_init(void);
HYD_Status HYD_BSCI_slurm_init(void);

extern struct HYD_BSCI_info HYD_BSCI_info;

#endif /* BSCI_H_INCLUDED */
